<?php
/**
 * Gravity Flow Step Feed Salesforce
 *
 * @package     GravityFlow
 * @subpackage  Classes/Gravity_Flow_Step_Feed_Salesforce
 * @copyright   Copyright (c) 2016-2024 Rocketgenius
 * @license     http://opensource.org/licenses/gpl-2.0.php GNU Public License
 * @since       2.9.7
 */

if ( ! class_exists( 'GFForms' ) ) {
	die();
}

/**
 * Class Gravity_Flow_Step_Feed_Salesforce
 */
class Gravity_Flow_Step_Feed_Salesforce extends Gravity_Flow_Step_Feed_Add_On {

	/**
	 * The step type.
	 *
	 * @var string
	 */
	public $_step_type = 'salesforce';

	/**
	 * The name of the class used by the add-on.
	 *
	 * @var string
	 */
	protected $_class_name = 'GF_Salesforce';

	/**
	 * Returns the step label.
	 *
	 * @return string
	 */
	public function get_label() {
		return 'Salesforce';
	}


	/**
	 * Returns the URL for the step icon.
	 *
	 * @return string
	 */
	public function get_icon_url() {
		if ( gravity_flow()->is_gravityforms_supported( '2.7.16.1' ) ) {
			return '<i class="gform-icon gform-icon--salesforce"></i>';
		}

		return $this->get_base_url() . '/images/salesforce-icon.svg';
	}

}

Gravity_Flow_Steps::register( new Gravity_Flow_Step_Feed_Salesforce() );
